Index: branches/sluengo/HeuristicLab.Problems.TradeRules/DataAnalysisSolution.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/DataAnalysisSolution.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/DataAnalysisSolution.cs	(revision 9262)
@@ -0,0 +1,168 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Drawing;
+using HeuristicLab.Common;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Problems.DataAnalysis {
+  /// <summary>
+  /// Abstract base class for data analysis solutions
+  /// </summary>
+  [StorableClass]
+  public abstract class DataAnalysisSolution : ResultCollection, IDataAnalysisSolution {
+    private const string ModelResultName = "Model";
+    private const string ProblemDataResultName = "ProblemData";
+
+    public string Filename { get; set; }
+
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Function; }
+    }
+
+    #region properties
+    public IDataAnalysisModel Model {
+      get { return (IDataAnalysisModel)this[ModelResultName].Value; }
+      protected set {
+        if (this[ModelResultName].Value != value) {
+          if (value != null) {
+            this[ModelResultName].Value = value;
+            OnModelChanged();
+          }
+        }
+      }
+    }
+
+    public IDataAnalysisProblemData ProblemData {
+      get { return (IDataAnalysisProblemData)this[ProblemDataResultName].Value; }
+      set {
+        if (this[ProblemDataResultName].Value != value) {
+          if (value != null) {
+            ProblemData.Changed -= new EventHandler(ProblemData_Changed);
+            this[ProblemDataResultName].Value = value;
+            ProblemData.Changed += new EventHandler(ProblemData_Changed);
+            OnProblemDataChanged();
+          }
+        }
+      }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected DataAnalysisSolution(bool deserializing) : base(deserializing) { }
+    protected DataAnalysisSolution(DataAnalysisSolution original, Cloner cloner)
+      : base(original, cloner) {
+      name = original.Name;
+      description = original.Description;
+    }
+    public DataAnalysisSolution(IDataAnalysisModel model, IDataAnalysisProblemData problemData)
+      : base() {
+      name = ItemName;
+      description = ItemDescription;
+      Add(new Result(ModelResultName, "The data analysis model.", model));
+      Add(new Result(ProblemDataResultName, "The data analysis problem data.", problemData));
+
+      problemData.Changed += new EventHandler(ProblemData_Changed);
+    }
+
+    protected abstract void RecalculateResults();
+
+    private void ProblemData_Changed(object sender, EventArgs e) {
+      OnProblemDataChanged();
+    }
+
+    public event EventHandler ModelChanged;
+    protected virtual void OnModelChanged() {
+      RecalculateResults();
+      var listeners = ModelChanged;
+      if (listeners != null) listeners(this, EventArgs.Empty);
+    }
+
+    public event EventHandler ProblemDataChanged;
+    protected virtual void OnProblemDataChanged() {
+      RecalculateResults();
+      var listeners = ProblemDataChanged;
+      if (listeners != null) listeners(this, EventArgs.Empty);
+    }
+
+    #region INamedItem Members
+    [Storable]
+    protected string name;
+    public string Name {
+      get { return name; }
+      set {
+        if (!CanChangeName) throw new NotSupportedException("Name cannot be changed.");
+        if (!(name.Equals(value) || (value == null) && (name == string.Empty))) {
+          CancelEventArgs<string> e = value == null ? new CancelEventArgs<string>(string.Empty) : new CancelEventArgs<string>(value);
+          OnNameChanging(e);
+          if (!e.Cancel) {
+            name = value == null ? string.Empty : value;
+            OnNameChanged();
+          }
+        }
+      }
+    }
+    public virtual bool CanChangeName {
+      get { return true; }
+    }
+    [Storable]
+    protected string description;
+    public string Description {
+      get { return description; }
+      set {
+        if (!CanChangeDescription) throw new NotSupportedException("Description cannot be changed.");
+        if (!(description.Equals(value) || (value == null) && (description == string.Empty))) {
+          description = value == null ? string.Empty : value;
+          OnDescriptionChanged();
+        }
+      }
+    }
+    public virtual bool CanChangeDescription {
+      get { return true; }
+    }
+
+    public override string ToString() {
+      return Name;
+    }
+
+    public event EventHandler<CancelEventArgs<string>> NameChanging;
+    protected virtual void OnNameChanging(CancelEventArgs<string> e) {
+      var handler = NameChanging;
+      if (handler != null) handler(this, e);
+    }
+
+    public event EventHandler NameChanged;
+    protected virtual void OnNameChanged() {
+      var handler = NameChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+      OnToStringChanged();
+    }
+
+    public event EventHandler DescriptionChanged;
+    protected virtual void OnDescriptionChanged() {
+      var handler = DescriptionChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+    #endregion
+  }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Evaluator/EvaluatorTradeRules.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Evaluator/EvaluatorTradeRules.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Evaluator/EvaluatorTradeRules.cs	(revision 9262)
@@ -0,0 +1,75 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;
+using HeuristicLab.Problems.DataAnalysis.Symbolic;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    [Item("Trade Rules Evaluator", "Calculates the profit")]
+    [StorableClass]
+    public class EvaluatorTradeRules : TradeRulesSingleObjectiveEvaluator
+    {
+        private static int initialTraining;
+        private static int initialTest;
+        public override bool Maximization { get { return true; } }
+
+        [StorableConstructor]
+        protected EvaluatorTradeRules(bool deserializing) : base(deserializing) { }
+        protected EvaluatorTradeRules(EvaluatorTradeRules original, Cloner cloner)
+            : base(original, cloner)
+        {
+        }
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new EvaluatorTradeRules(this, cloner);
+        }
+
+        public EvaluatorTradeRules() : base() { }
+
+        public override IOperation Apply()
+        {
+            var solution = SymbolicExpressionTreeParameter.ActualValue;
+            IEnumerable<int> rows = GenerateRowsToEvaluate();
+            initialTraining = initialTrainingValue();
+            initialTest = initialTestValue();
+            double quality = Calculate((ITradeRulesExpresionTree) SymbolicDataAnalysisTreeInterpreterParameter.ActualValue, solution, EstimationLimitsParameter.ActualValue.Lower, EstimationLimitsParameter.ActualValue.Upper, ProblemDataParameter.ActualValue, rows);
+            QualityParameter.ActualValue = new DoubleValue(quality);
+            ITradeRulesExpresionTree interpreter = (ITradeRulesExpresionTree)SymbolicDataAnalysisTreeInterpreterParameter.ActualValue;
+            interpreter.clearVariables();
+            return base.Apply();
+        }
+
+        public static double Calculate(ITradeRulesExpresionTree interpreter, ISymbolicExpressionTree solution, double lowerEstimationLimit, double upperEstimationLimit, IRegressionProblemData problemData, IEnumerable<int> rows)
+        {
+            interpreter.setInitialTraining(initialTraining);
+            interpreter.setInitialTest(initialTest);
+            IEnumerable<double> estimatedValues = interpreter.GetSymbolicExpressionTreeValues(solution, problemData.Dataset, rows);
+            
+            double tradingCash = OnlineTradeRulesCalculator.Calculate(estimatedValues, problemData, problemData.TrainingIndices);
+            
+            return tradingCash;
+        }
+
+        public override double Evaluate(IExecutionContext context, ISymbolicExpressionTree tree, IRegressionProblemData problemData, IEnumerable<int> rows)
+        {
+            SymbolicDataAnalysisTreeInterpreterParameter.ExecutionContext = context;
+            EstimationLimitsParameter.ExecutionContext = context;
+
+            double r2 = Calculate((ITradeRulesExpresionTree) SymbolicDataAnalysisTreeInterpreterParameter.ActualValue, tree, EstimationLimitsParameter.ActualValue.Lower, EstimationLimitsParameter.ActualValue.Upper, problemData, rows);
+            SymbolicDataAnalysisTreeInterpreterParameter.ExecutionContext = null;
+            EstimationLimitsParameter.ExecutionContext = null;
+         
+
+            return r2;
+        }
+    }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Evaluator/OnlineTradeRulesCalculator.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Evaluator/OnlineTradeRulesCalculator.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Evaluator/OnlineTradeRulesCalculator.cs	(revision 9262)
@@ -0,0 +1,228 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Problems.TradeRules
+{
+    class OnlineTradeRulesCalculator
+    {
+        public static double Calculate(IEnumerable<double> estimatedValues, IRegressionProblemData problemData, IEnumerable<int> rows)
+        {/*
+            const double commission = 0.25;
+            const double EAR = 4.00;  //Effective Anual Rate 
+
+            double DayRat = 0; //One day interest
+            double interest = 0.0; // Interest for one day
+            double[] arrayDate = problemData.Dataset.GetDoubleValues("\"Date\"").ToArray(); //Array with all dates in UNIX format
+
+            //int count = rows.ToList()[0];
+ 
+            bool intoMarket = false;//Equivalent to be into the market
+            int totalTradeDays = 0;
+            int numberTrades = 0;
+            int tradeDays = 0;
+            double dayBefore = 0.0;
+            double yesterday = 0.0;
+            double buyPrice = 0.0;
+            double sellPrice = 0.0;
+            string stringPrice = "";
+            int nShares = 0;
+            double cash = 10000.00;
+            double expend = 0.0;
+            double equity = 0.0;
+            double profit1 = 0.0;
+            double charged = 0.0;
+
+            IEnumerator<int> initialRow = rows.GetEnumerator();
+            initialRow.MoveNext();
+            int numDays1 = (int)arrayDate[initialRow.Current-1];
+            int numDays2 = (int) arrayDate[(initialRow.Current)];
+            int count = initialRow.Current + 1;
+            
+            IEnumerator<double> enumerator = estimatedValues.GetEnumerator();
+            enumerator.MoveNext();
+            dayBefore = enumerator.Current;
+            enumerator.MoveNext();
+            yesterday = enumerator.Current;
+
+            DayRat = 360 * (Math.Pow((1 + (EAR / 100)), (1 / 360)) - 1);
+
+            while (enumerator.MoveNext())
+            {
+                if (!intoMarket)
+                {
+                    if (dayBefore == -1 && yesterday == 1)
+                    {
+                        intoMarket = true;
+                        stringPrice = problemData.Dataset.GetValue(count, 0); //Extracting Open values
+                        buyPrice = Convert.ToDouble(stringPrice);
+                        totalTradeDays++; numberTrades++; tradeDays++; //Increasing trading variables
+                        nShares = (int)Math.Floor(cash / (buyPrice * (1.0 + commission / 100)));
+                        expend = buyPrice * nShares * (1 + commission / 100);
+                        cash = cash - expend + interest;
+                        equity = cash + nShares * buyPrice * (1 - commission / 100);
+                        interest = cash * Math.Pow((1 + DayRat / 360), numDays2) - cash;
+                    }
+                    else  //Dia normal fuera del mercado
+                    {
+                        cash = cash + interest;
+                        equity = equity + cash;
+                        interest = cash * Math.Pow((1 + DayRat / 360), numDays2) - cash;
+                    }
+
+                }
+                else if (dayBefore == 1 && yesterday == -1)
+                {
+                    intoMarket = false;
+                    stringPrice = problemData.Dataset.GetValue(count, 0); //Extracting Open values
+                    sellPrice = Convert.ToDouble(stringPrice);
+                    profit1 += sellPrice - buyPrice;
+                    charged = sellPrice * nShares * (1 - commission / 100);
+                    cash = cash + charged + interest;
+                    equity = cash;
+                    interest = cash * Math.Pow((1 + DayRat / 360), numDays2) - cash;
+                    nShares = 0;
+                }
+                else
+                {
+                    cash = cash + interest;
+                    tradeDays += numDays1;
+                    totalTradeDays += numDays1;
+                    equity = cash + nShares * Convert.ToDouble(problemData.Dataset.GetValue(count, 0)) * (1 - commission / 100);
+                    interest = cash * Math.Pow((1 + DayRat / 360), numDays2) - cash;
+                }
+
+                dayBefore = yesterday;
+                yesterday = enumerator.Current;
+                numDays1 = numDays2;
+                numDays2 = (int) arrayDate[count];
+                count++;
+            }
+            if (intoMarket)
+            {
+                intoMarket = false;
+                stringPrice = problemData.Dataset.GetValue(count, 0); //Extracting Open values
+                sellPrice = Convert.ToDouble(stringPrice);
+                profit1 += sellPrice - buyPrice;
+                charged = sellPrice * nShares * (1 - commission / 100);
+                cash = cash + charged + interest;
+                equity = cash;
+                nShares = 0;
+            }
+            return numDays1;*/
+
+            const double commission = 0.25;
+            const double EAR = 4.00;  //Effective Anual Rate 
+
+            double DayRat = 0; //One day interest
+            double interest = 0.0; // Interest for one day
+            double[] arrayDate = problemData.Dataset.GetDoubleValues("\"Date\"").ToArray(); //Array with all dates in UNIX format
+            int nDias1 = 0;
+            int nDias2 = 0;
+
+
+            bool intoMarket = false;//Equivalent to be into the market
+            int totalTradeDays = 0;
+            int numberTrades = 0;
+            int tradeDays = 0;
+            double buyPrice = 0.0;
+            double sellPrice = 0.0;
+            string stringPrice = "";
+            int nShares = 0;
+            double cash = 10000.00;
+            double expend = 0.0;
+            double equity = 0.0;
+            double profit1 = 0.0;
+            double charged = 0.0;
+
+            //SECOND EVALUATOR
+            var enumerator = estimatedValues.GetEnumerator();
+            int count = rows.ToList()[2];
+            int count2 = 2;
+            int date1 = (int)arrayDate[rows.ToList()[0]];
+            int date2 = (int)arrayDate[rows.ToList()[1]];
+
+            enumerator.MoveNext();
+            double dayBefore = enumerator.Current;
+            enumerator.MoveNext();
+            double yesterday = enumerator.Current;
+            
+            DayRat = 268 * (Math.Pow((1 + (EAR / 100)),(1 / 268)) - 1);
+            nDias2 = date2 - date1;
+            
+            while (enumerator.MoveNext())
+            {
+                if (!intoMarket)
+                {
+                    if (dayBefore == -1 && yesterday == 1)
+                    {
+                        intoMarket = true;
+                        stringPrice = problemData.Dataset.GetValue(count, 1); //Extracting Open values
+                        buyPrice = Convert.ToDouble(stringPrice);
+                        totalTradeDays++; numberTrades++; tradeDays++; //Increasing trading variables
+                        nShares = (int)Math.Floor(cash / (buyPrice * (1.0 + commission / 100)));
+                        expend = buyPrice * nShares * (1 + commission / 100);
+                        cash = cash - expend + interest;
+                        equity = cash + nShares * buyPrice * (1 - commission / 100);
+                        interest = cash * Math.Pow((1 + DayRat / 268), nDias2) - cash;
+                    }
+                    else  //Dia normal fuera del mercado
+                    {
+                        tradeDays++;
+                        totalTradeDays++;
+                        cash = cash + interest;
+                        equity = equity+cash;
+                        interest = cash * Math.Pow((1 + DayRat / 268), nDias2) - cash;
+                    }
+                }
+                else if (dayBefore == 1 && yesterday == -1)
+                {
+                    intoMarket = false;
+                    stringPrice = problemData.Dataset.GetValue(count, 1); //Extracting Open values
+                    sellPrice = Convert.ToDouble(stringPrice);
+                    profit1 += sellPrice - buyPrice;
+                    charged = sellPrice * nShares * (1 - commission / 100);
+                    cash = cash + charged+interest;
+                    equity = cash;
+                    interest = cash + Math.Pow((1 + DayRat / 268), nDias2) - cash;
+                    nShares = 0;
+                }
+                else
+                {
+                    cash = cash + interest;
+                    tradeDays++;
+                    totalTradeDays++;
+                    equity = cash + nShares * Convert.ToDouble(problemData.Dataset.GetValue(count,1)) * (1 - commission / 100);
+                    interest = cash * Math.Pow((1 + DayRat / 268), nDias2) - cash;
+                }
+
+                dayBefore = yesterday;
+                yesterday = enumerator.Current;
+                date1 = date2;
+                date2 = (int)arrayDate[rows.ToList()[count2]];
+                
+                int nDiasAux = nDias1;
+                nDias1 = nDias2;
+                nDias2 = date2-date1;
+
+                count++;
+                count2++;
+            }
+
+            if (intoMarket)
+            {
+                intoMarket = false;
+                stringPrice = problemData.Dataset.GetValue((count-1), 1); //Extracting Open values
+                sellPrice = Convert.ToDouble(stringPrice);
+                profit1 += sellPrice - buyPrice;
+                charged = sellPrice * nShares * (1 - commission / 100);
+                cash = cash + charged + interest;
+                equity = cash;
+                nShares = 0;
+            }
+            return cash;
+        }
+    }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Evaluator/TradeRulesAnalysisEvaluator.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Evaluator/TradeRulesAnalysisEvaluator.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Evaluator/TradeRulesAnalysisEvaluator.cs	(revision 9262)
@@ -0,0 +1,127 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Random;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  [StorableClass]
+  public abstract class TradeRulesAnalysisEvaluator<T> : SingleSuccessorOperator,
+    ISymbolicDataAnalysisEvaluator<T>, ISymbolicDataAnalysisInterpreterOperator, ISymbolicDataAnalysisBoundedOperator
+  where T : class, IDataAnalysisProblemData {
+    private const string RandomParameterName = "Random";
+    private const string SymbolicExpressionTreeParameterName = "SymbolicExpressionTree";
+    private const string SymbolicDataAnalysisTreeInterpreterParameterName = "SymbolicExpressionTreeInterpreter";
+    private const string ProblemDataParameterName = "ProblemData";
+    private const string EstimationLimitsParameterName = "EstimationLimits";
+    private const string EvaluationPartitionParameterName = "EvaluationPartition";
+    private const string RelativeNumberOfEvaluatedSamplesParameterName = "RelativeNumberOfEvaluatedSamples";
+
+    public override bool CanChangeName { get { return false; } }
+
+    #region parameter properties
+    public IValueLookupParameter<IRandom> RandomParameter {
+      get { return (IValueLookupParameter<IRandom>)Parameters[RandomParameterName]; }
+    }
+    public ILookupParameter<ISymbolicExpressionTree> SymbolicExpressionTreeParameter {
+      get { return (ILookupParameter<ISymbolicExpressionTree>)Parameters[SymbolicExpressionTreeParameterName]; }
+    }
+    public ILookupParameter<ISymbolicDataAnalysisExpressionTreeInterpreter> SymbolicDataAnalysisTreeInterpreterParameter {
+      get { return (ILookupParameter<ISymbolicDataAnalysisExpressionTreeInterpreter>)Parameters[SymbolicDataAnalysisTreeInterpreterParameterName]; }
+    }
+    public IValueLookupParameter<T> ProblemDataParameter {
+      get { return (IValueLookupParameter<T>)Parameters[ProblemDataParameterName]; }
+    }
+
+    public IValueLookupParameter<IntRange> EvaluationPartitionParameter {
+      get { return (IValueLookupParameter<IntRange>)Parameters[EvaluationPartitionParameterName]; }
+    }
+    public IValueLookupParameter<DoubleLimit> EstimationLimitsParameter {
+      get { return (IValueLookupParameter<DoubleLimit>)Parameters[EstimationLimitsParameterName]; }
+    }
+    public IValueLookupParameter<PercentValue> RelativeNumberOfEvaluatedSamplesParameter {
+      get { return (IValueLookupParameter<PercentValue>)Parameters[RelativeNumberOfEvaluatedSamplesParameterName]; }
+    }
+    #endregion
+
+
+    [StorableConstructor]
+    protected TradeRulesAnalysisEvaluator(bool deserializing) : base(deserializing) { }
+    protected TradeRulesAnalysisEvaluator(TradeRulesAnalysisEvaluator<T> original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public TradeRulesAnalysisEvaluator()
+      : base() {
+      Parameters.Add(new ValueLookupParameter<IRandom>(RandomParameterName, "The random generator to use."));
+      Parameters.Add(new LookupParameter<ISymbolicDataAnalysisExpressionTreeInterpreter>(SymbolicDataAnalysisTreeInterpreterParameterName, "The interpreter that should be used to calculate the output values of the symbolic data analysis tree."));
+      Parameters.Add(new LookupParameter<ISymbolicExpressionTree>(SymbolicExpressionTreeParameterName, "The symbolic data analysis solution encoded as a symbolic expression tree."));
+      Parameters.Add(new ValueLookupParameter<T>(ProblemDataParameterName, "The problem data on which the symbolic data analysis solution should be evaluated."));
+      Parameters.Add(new ValueLookupParameter<IntRange>(EvaluationPartitionParameterName, "The start index of the dataset partition on which the symbolic data analysis solution should be evaluated."));
+      Parameters.Add(new ValueLookupParameter<DoubleLimit>(EstimationLimitsParameterName, "The upper and lower limit that should be used as cut off value for the output values of symbolic data analysis trees."));
+      Parameters.Add(new ValueLookupParameter<PercentValue>(RelativeNumberOfEvaluatedSamplesParameterName, "The relative number of samples of the dataset partition, which should be randomly chosen for evaluation between the start and end index."));
+    }
+
+    protected IEnumerable<int> GenerateRowsToEvaluate() {
+      return GenerateRowsToEvaluate(RelativeNumberOfEvaluatedSamplesParameter.ActualValue.Value);
+    }
+
+    protected int initialTrainingValue()
+    {
+        return EvaluationPartitionParameter.ActualValue.Start;
+    }
+    protected int initialTestValue()
+    {
+        return ProblemDataParameter.ActualValue.TestPartition.Start;
+    }
+
+    protected IEnumerable<int> GenerateRowsToEvaluate(double percentageOfRows) {
+
+
+      IEnumerable<int> rows;
+      int samplesStart = EvaluationPartitionParameter.ActualValue.Start;
+      int samplesEnd = EvaluationPartitionParameter.ActualValue.End;
+      int testPartitionStart = ProblemDataParameter.ActualValue.TestPartition.Start;
+      int testPartitionEnd = ProblemDataParameter.ActualValue.TestPartition.End;
+
+      if (samplesEnd < samplesStart) throw new ArgumentException("Start value is larger than end value.");
+
+      if (percentageOfRows.IsAlmost(1.0))
+        rows = Enumerable.Range(samplesStart, samplesEnd - samplesStart);
+      else {
+        int seed = RandomParameter.ActualValue.Next();
+        int count = (int)((samplesEnd - samplesStart) * percentageOfRows);
+        if (count == 0) count = 1;
+        rows = RandomEnumerable.SampleRandomNumbers(seed, samplesStart, samplesEnd, count);
+      }
+
+      return rows.Where(i => i < testPartitionStart || testPartitionEnd <= i);
+    }
+  }
+}
Index: branches/sluengo/HeuristicLab.Problems.TradeRules/Evaluator/TradeRulesAnalysisSingleObjectiveEvaluator.cs
===================================================================
--- branches/sluengo/HeuristicLab.Problems.TradeRules/Evaluator/TradeRulesAnalysisSingleObjectiveEvaluator.cs	(revision 9262)
+++ branches/sluengo/HeuristicLab.Problems.TradeRules/Evaluator/TradeRulesAnalysisSingleObjectiveEvaluator.cs	(revision 9262)
@@ -0,0 +1,59 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using System.Collections.Generic;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HeuristicLab.Problems.DataAnalysis.Symbolic;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Problems.TradeRules {
+  [StorableClass]
+  public abstract class TradeRulesAnalysisSingleObjectiveEvaluator<T> : TradeRulesAnalysisEvaluator<T>, ISymbolicDataAnalysisSingleObjectiveEvaluator<T>
+   where T : class, IDataAnalysisProblemData {
+    private const string QualityParameterName = "Quality";
+    #region parameter properties
+    public ILookupParameter<DoubleValue> QualityParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters[QualityParameterName]; }
+    }
+    #endregion
+    #region properties
+    public abstract bool Maximization { get; }
+    #endregion
+    [StorableConstructor]
+    protected TradeRulesAnalysisSingleObjectiveEvaluator(bool deserializing) : base(deserializing) { }
+    protected TradeRulesAnalysisSingleObjectiveEvaluator(TradeRulesAnalysisSingleObjectiveEvaluator<T> original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    protected TradeRulesAnalysisSingleObjectiveEvaluator()
+      : base() {
+      Parameters.Add(new LookupParameter<DoubleValue>(QualityParameterName, "The quality of the evaluated symbolic data analysis solution."));
+    }
+
+    public abstract double Evaluate(IExecutionContext context, ISymbolicExpressionTree tree, T problemData, IEnumerable<int> rows);
+  }
+}
